unit vfo;

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,winprocs,
  StdCtrls, ExtCtrls,  Menus, jpeg;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Label1: TLabel;
    Button3: TButton;
    RadioGroup3: TRadioGroup;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beenden1: TMenuItem;
    Frequenz1: TMenuItem;
    Frequenz2: TMenuItem;
    Up1: TMenuItem;
    Down1: TMenuItem;
    Quit1: TMenuItem;
    Zwischenfrequenz1: TMenuItem;
    Schrittweite1: TMenuItem;
    N100kHz1: TMenuItem;
    N10kHz1: TMenuItem;
    N1kHz1: TMenuItem;
    N100Hz1: TMenuItem;
    N10Hz1: TMenuItem;
    N1Hz1: TMenuItem;
    Label2: TLabel;
    RadioGroup4: TRadioGroup;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);

    procedure RadioGroup1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure frequenzausgabe(fx:longint);
    procedure Button5Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    function  inttostrdez(za :longint):string;
    procedure cfg_write;
    procedure read_cfg_line(var dat :longint;sonst:longint);
    procedure RG2wert;
    procedure RG1wert;
    procedure N100kHz1Click(Sender: TObject);
    procedure N10kHz1Click(Sender: TObject);
    procedure N1kHz1Click(Sender: TObject);
    procedure N100Hz1Click(Sender: TObject);
    procedure N10Hz1Click(Sender: TObject);
    procedure N1Hz1Click(Sender: TObject);
    procedure PortSetzen;



  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1           :TForm1;
  f,s,fz,fe,ft,fx :longint;
  f160            :longint;
  f80             :longint;
  f40             :longint;
  f30             :longint;
  f20             :longint;
  f17             :longint;
  f15             :longint;
  f12             :longint;
  f10             :longint;
  add             :boolean;
  cfgfile         :text;
  fz_ein          :longint;
  ind             :longint;
  zf_add          :longint;
  speed           :longint;
  result          : dword;
  Cid             : THandle;
  DCB             : TDCB;
  baud            :integer;


implementation

{$R *.DFM}
function TForm1.inttostrdez(za :longint):string;
var s        :string;
begin
s:=inttostr(za);
if length(s)>3 then insert('.',s,length(s)-2);
if length(s)>7 then insert('.',s,length(s)-6);
inttostrdez:=s
end;

function serial_open(comport:integer):integer;
const
 usedcom :array[0..5] of char = 'COMx';
var h :dword;
begin
 usedcom[3]:=chr(comport + $31);
 h:=createfile(usedcom,GENERIC_READ or GENERIC_WRITE,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
 if h = INVALID_HANDLE_VALUE then
                              serial_open:=-1
                             else
                               serial_open:=h;
 getlasterror;
end;


procedure TForm1.PortSetzen;
begin
case RadioGroup3.itemindex+1 of
1:begin cid:=serial_open(0) end;
2:begin cid:=serial_open(1) end;
3:begin cid:=serial_open(2) end;
4:begin cid:=serial_open(3) end;
 end;
setupcomm(cid,2,5);
GetCommState(Cid,DCB);
case RadioGroup4.itemindex of
0:begin dcb.BaudRate:=cbr_9600;baud:=9600 end;
1:begin dcb.BaudRate:=cbr_19200;baud:=19200 end;
2:begin dcb.BaudRate:=cbr_38400;baud:=38400 end;
3:begin dcb.BaudRate:=cbr_57600;baud:=57600 end;
else
 begin dcb.BaudRate:=cbr_9600;baud:=9600 end;
end;
dcb.ByteSize:=8;
dcb.Parity:=noparity;
dcb.StopBits:=onestopbit;
dcb.flags:=$01;
setcommstate(cid,dcb);
form1.caption:='VFO (DK3WX)    COM '+inttostr(RadioGroup3.itemindex+1)+ ' /'+inttostr(baud);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
form1.top:=1;
form1.left:=1;
assignfile(cfgfile,'vfo.cfg');
  {$I-}
Reset(cfgfile);
  {$I+}
if IOResult = 0 then begin
                     read_cfg_line(fx,14000000);
                     read_cfg_line(fe,35000000);
                     read_cfg_line(ft,100000000);
                     read_cfg_line(fz,9000000);
                     read_cfg_line(f160,1800000);
                     read_cfg_line(f80,3500000);
                     read_cfg_line(f40,7000000);
                     read_cfg_line(f30,10100000);
                     read_cfg_line(f20,14000000);
                     read_cfg_line(f17,18068000);
                     read_cfg_line(f15,21000000);
                     read_cfg_line(f12,24890000);
                     read_cfg_line(f10,28000000);
                     read_cfg_line(fz_ein,1);
                     if fz_ein=1 then checkbox1.checked:=true
                                 else checkbox1.checked:=false;
                     read_cfg_line(zf_add,1);
                     read_cfg_line(ind,1);
                     RadioGroup3.itemindex:=ind-1;
                     read_cfg_line(ind,1);
                     RadioGroup2.itemindex:=ind;
                     rg2wert;
                     read_cfg_line(ind,1);
                     RadioGroup1.itemindex:=ind;
                     rg1wert;
                     read_cfg_line(speed,1);
                     RadioGroup4.itemindex:=speed;
                     f:=fx;
                     end
                else begin
                     f:=14000000;
                     fe:=35000000;
                     ft:=100000000;
                     fz:=9000000;
                     f160:=1800000;
                     f80:=3500000;
                     f40:=7000000;
                     f30:=10100000;
                     f20:=14000000;
                     f17:=18068000;
                     f15:=21000000;
                     f12:=24890000;
                     f10:=28000000;
                     fz_ein:=1;
                     checkbox1.checked:=true;
                     RadioGroup1.itemindex:=3;
                     RadioGroup2.itemindex:=3;
                     RadioGroup3.itemindex:=1;
                     RadioGroup4.itemindex:=0;
                     s:=100;
                     add:=false;
                     zf_add:=$0f;
                     end;
{form1.windowstate:=wsmaximized;}
label1.caption:=inttostrdez(f)+' Hz';
button5.caption:='&ZF = '+inttostrdez(fz)+' Hz';
RadioGroup3.enabled:=true;
RadioGroup4.enabled:=true;
portsetzen;
form1.caption:='VFO (DK3WX)    COM '+inttostr(RadioGroup3.itemindex+1)+ ' /'+inttostr(baud);
frequenzausgabe(f)
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
f:=f+s;
label1.caption:=inttostrdez(f)+' Hz';
frequenzausgabe(f)
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
f:=f-s;
label1.caption:=inttostrdez(f)+' Hz';
frequenzausgabe(f)
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
rg2wert;
label1.caption:=inttostrdez(f)+' Hz';
frequenzausgabe(f)
end;

procedure TForm1.RG2wert;
begin
case Radiogroup2.itemindex of
0:begin f:=f160 ;if (zf_add and $0001)<>0 then add:=true else add:=false end;
1:begin f:=f80  ;if (zf_add and $0002)<>0 then add:=true else add:=false end;
2:begin f:=f40  ;if (zf_add and $0004)<>0 then add:=true else add:=false end;
3:begin f:=f30  ;if (zf_add and $0008)<>0 then add:=true else add:=false end;
4:begin f:=f20  ;if (zf_add and $0010)<>0 then add:=true else add:=false end;
5:begin f:=f17  ;if (zf_add and $0020)<>0 then add:=true else add:=false end;
6:begin f:=f15  ;if (zf_add and $0040)<>0 then add:=true else add:=false end;
7:begin f:=f12  ;if (zf_add and $0080)<>0 then add:=true else add:=false end;
8:begin f:=f10  ;if (zf_add and $0100)<>0 then add:=true else add:=false end;
end;
end;


procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
rg1wert;
end;

procedure TForm1.RG1wert;
begin
case RadioGroup1.itemindex of
0:begin
       s:=100000;
       f:=trunc(f/100000)*100000;
       label1.caption:=inttostrdez(f)+' Hz';
       frequenzausgabe(f)
  end;
1:begin
       s:=10000;
       f:=trunc(f/10000)*10000;
       label1.caption:=inttostrdez(f)+' Hz';
       frequenzausgabe(f)
  end;
2:begin
       s:=1000;
       f:=trunc(f/1000)*1000;
       label1.caption:=inttostrdez(f)+' Hz';
       frequenzausgabe(f)
  end;
3:begin
       s:=100;
       f:=trunc(f/100)*100;
       label1.caption:=inttostrdez(f)+' Hz';
       frequenzausgabe(f)
  end;
4:begin
       s:=10;
       f:=trunc(f/10)*10;
       label1.caption:=inttostrdez(f)+' Hz';
       frequenzausgabe(f)
  end;
5:begin s:=1 end;
end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
cfg_write;
close;
end;


procedure tform1.frequenzausgabe(fx:longint);

  var
       ffeld : array[1..4] of byte;
       fptr  : ^byte;
       z,x,k   : real;
       li    : longint;
       b0,b1,b2,b3:byte;
begin

if checkbox1.checked then
 if add then x:=fx+fz else x:=fx-fz
 else x:=fx;
label2.caption:='VFO = '+inttostrdez(round(x))+' Hz';
if x>fe then application.messagebox('Frequenz zu gro! Diese Frequenz liegt ber dem Maximumwert','Fehler',0)
else
begin
k:=42.94967296*100000000/ft;
z:=k*x;
li:=round(z);
b0:=trunc(li/16777216);
ffeld[4]:=b0;
li:=li-b0*16777216;
b1:=trunc(li/65536);
ffeld[3]:=b1;
li:=li-b1*65536;
b2:=trunc(li/256);
ffeld[2]:=b2;
li:=li-b2*256;
ffeld[1]:=trunc(li);
fptr:=@ffeld;
writefile(cid,ffeld,4,result,nil);
ffeld[1]:=$50;
writefile(cid,ffeld,1,result,nil);
end;
end;


procedure TForm1.Button5Click(Sender: TObject);
var s     :string;
begin
s:=inputbox('Zwischenfrequenz','Zwischenfrequenz in Hz eingeben!',inttostr(fz));
fz:=strtoint(s);
button5.caption:='&ZF = '+inttostrdez(fz)+' Hz';
frequenzausgabe(f)
end;

procedure TForm1.Button3Click(Sender: TObject);
var s     :string;
begin
s:=inputbox('Frequenz','Frequenz in Hz eingeben!',inttostr(f));
f:=strtoint(s);
label1.caption:=inttostrdez(f)+' Hz';
frequenzausgabe(f)
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
frequenzausgabe(f)
end;

procedure TForm1.cfg_write;
begin
 if checkbox1.checked then fz_ein:=1 else fz_ein:=0;
 rewrite(cfgfile);
 writeln(cfgfile,'Startfrequenz    ='+inttostr(f));
 writeln(cfgfile,'Endfrequenz      ='+inttostr(fe));
 writeln(cfgfile,'Taktfrequenz     ='+inttostr(ft));
 writeln(cfgfile,'Zwischenfrequenz ='+inttostr(fz));
 writeln(cfgfile,'Frequenz 160m    ='+inttostr(f160));
 writeln(cfgfile,'Frequenz 80m     ='+inttostr(f80));
 writeln(cfgfile,'Frequenz 40m     ='+inttostr(f40));
 writeln(cfgfile,'Frequenz 30m     ='+inttostr(f30));
 writeln(cfgfile,'Frequenz 20m     ='+inttostr(f20));
 writeln(cfgfile,'Frequenz 17m     ='+inttostr(f17));
 writeln(cfgfile,'Frequenz 15m     ='+inttostr(f15));
 writeln(cfgfile,'Frequenz 12m     ='+inttostr(f12));
 writeln(cfgfile,'Frequenz 10m     ='+inttostr(f10));
 writeln(cfgfile,'ZF ein           ='+inttostr(fz_ein));
 writeln(cfgfile,'ZF-Addition      ='+inttostr(zf_add));
 writeln(cfgfile,'Comport          ='+inttostr(RadioGroup3.itemindex+1));
 writeln(cfgfile,'Bandschalter     ='+inttostr(RadioGroup2.itemindex));
 writeln(cfgfile,'Schrittweite     ='+inttostr(RadioGroup1.itemindex));
 writeln(cfgfile,'Datenrate        ='+inttostr(RadioGroup4.itemindex));

 closefile(cfgfile);
end;

procedure TForm1.read_cfg_line(var dat :longint;sonst:longint);
var Zeile :string;
    code  :integer;
    wert  :longint;
begin
 readln(cfgfile,zeile);
 delete(zeile,1,pos('=',zeile));
 Val(zeile, wert, Code);
 if code <> 0 then dat:=sonst else dat:=wert;
end;

procedure TForm1.N100kHz1Click(Sender: TObject);
begin
radiogroup1.itemindex:=0;
rg1wert;
end;

procedure TForm1.N10kHz1Click(Sender: TObject);
begin
radiogroup1.itemindex:=1;
rg1wert;
end;

procedure TForm1.N1kHz1Click(Sender: TObject);
begin
radiogroup1.itemindex:=2;
rg1wert;
end;

procedure TForm1.N100Hz1Click(Sender: TObject);
begin
radiogroup1.itemindex:=3;
rg1wert;
end;

procedure TForm1.N10Hz1Click(Sender: TObject);
begin
radiogroup1.itemindex:=4;
rg1wert;
end;

procedure TForm1.N1Hz1Click(Sender: TObject);
begin
radiogroup1.itemindex:=5;
rg1wert
end;

end.
